/* 
 * File:   main.cpp
 * Author: forteller
 * ilosc krokow
 *
 * przygotowanie programu calkujacego metoda Simpsona.
        funkcja podcalkowa moze byc zdefiniowana w kodzie zrodlowym
        dane wejsciowe:
                przdzial calkowania
                ilosc krokow
 * 
 * Created on November 11, 2012, 3:50 PM
 * 
 * 1 Wczytywanie zmiennych
 * 2 Wyliczanie "punktow pomiaru"
 * 3 obliczanie wartosci funkcji w tych punktach dla zadanej zmiennej
 * 4 obliczanie pola pod wykresem metoda simspsona. Czyli wzor
 */

#include <iostream>
#include <cstdlib>
#include <math.h>

float f(float);
float simpson(float*,float,int);

const int N = 500; 
using namespace std;

int main(int argc, char** argv) {
    float pp, kp, krok, wynik;  //poczatek przedzialu, koniec przedzialu, krok, wynik
    float x[N],fx[N];           //tablica krancow podprzedzialow, tablica wartosci funkcji w tych krancach 
    int lkrokow;                //liczba krokow

    cout << "Podaj poczatek przedzialu calkowania: ";
    cin >> pp;
    cout << "Podaj koniec przedzialu calkowania: ";
    cin >> kp;
    cout << "Podaj liczbe krokow: ";
    cin >> lkrokow;
    cout << endl;

    krok = (kp - pp) / lkrokow;

    /*Wyliczanie krancow przedzialow*/
    float wartosc = pp;
    for (int i = 0; i <= lkrokow; i++) {
        x[i] = wartosc;
        fx[i] = f(wartosc);
        
        wartosc += krok;
    }
    
    wynik=simpson(x,krok,lkrokow);
    
    cout << "Simpson tako rzecze: " << wynik;

    return 0;
}

float f(float x) {
    double e = 0.5+exp(-x*x)+sin(x);
    //cout << "x: " << x << "e: " << e << endl;
    float fx = e; //~3,5 - miejsce zerowe

    return fx;
};

float simpson(float tab[], float kroczek, int length) {
    float a,b,calkap[N],pole=0;
                                                                //Obliczanie calki oznaczonej metoda simspona
    for (int i = 1; i <= length; i++) {
        a=tab[i-1];                                             //a: poczatek danego podprzedzialu
        b=tab[i];                                               //b: koniec danego podprzedzialu
        calkap[i] = (f(a) + 4* f((a+b)/2) + f(b))/6 * kroczek;  //calkap: pole pod wykresem na danym podprzedziale. Ze wzoru.
        pole+=calkap[i];                                        //wyliczanie pola pod wykresem na calym przedziale
    }
    
    return pole;
};
